



void handleSerialDataIn(){
  while(Serial.available()){
    byte serinChar = Serial.read();
    if(protocolIndex == 0){
      if(serinChar == PROTO_CHAR_START){
        protocolIndex++;
      }
    }
    else{
      if(protocolIndex == 1){
        if(serinChar < PROTO_LENGTH_MAX){
          protocolLength    = serinChar;
          protocolDataIndex = 0; // reset index.
          protocolIndex++;
        }
        else{
          // ERROR: data length was too long! Reset protocol to beginning.
          Serial.println("ERROR >> Too much data.");
          protocolIndex = 0;
        }
      }
      else{
        if(protocolIndex == 2){
          protocolCmd = serinChar;
          protocolIndex++;
        }
        else{
          // record data packet.
          if(protocolDataIndex < protocolLength){
            protocolData[protocolDataIndex++] = serinChar;
          }
          else{
            if(serinChar == PROTO_CHAR_END){
              processData();
              protocolIndex = 0;
            }
            else{
              // Error: Expected stop byte, but didn't get it!
              Serial.println("ERROR >> Expected Protocol end.");
            }
          }
        }
      }
    }
  }
}



void processData(){
  int i = 0;
  //// Serial.println("PROCESS!");
  switch(protocolCmd){
  case PROTO_CMD_INFO_GET:
    {
      // Serial.println("Info get.");
      Serial.print(PROTO_CHAR_START);
      Serial.print(2, BYTE);
      Serial.print(PROTO_CMD_INFO_SET);
      /*
      for(int i=0; i<EEPROM_NAME_SIZE; i++){
        eepromVal = EEPROM.read(EEPROM_NAME_OFFSET+i);
        Serial.print(eepromVal, BYTE);
      }
      */
      Serial.print(EEPROM.read(EEPROM_VERSION_OFFSET), BYTE); // Version 
      Serial.print(0x00, BYTE); // ???
      Serial.print(PROTO_CHAR_END);
      break;
    }
    /*
  case PROTO_CMD_INFO_SET:
    {
      // Serial.println("Info set.");
      for(i=0; i<EEPROM_NAME_SIZE; i++){
        EEPROMwrite(EEPROM_NAME_OFFSET+i, protocolData[i]);
      }
      break;
    }
    */
  case PROTO_CMD_DATA_GET:
    {
      // Serial.print("d");
      updateInputs();
      Serial.print(PROTO_CHAR_START);
      Serial.print(42, BYTE);
      Serial.print(PROTO_CMD_DATA_SET);

      // Inputs 0-4
      int inVal = inputVals[0];
      int inValDiv = inVal/8;
      Serial.print(inValDiv, BYTE);
      Serial.print(inVal-(inValDiv*8), BYTE);
      inVal = inputVals[1];
      inValDiv = inVal/8;
      Serial.print(inValDiv, BYTE);
      Serial.print(inVal-(inValDiv*8), BYTE);
      inVal = inputVals[2];
      inValDiv = inVal/8;
      Serial.print(inValDiv, BYTE);
      Serial.print(inVal-(inValDiv*8), BYTE);
      inVal = inputVals[3];
      inValDiv = inVal/8;
      Serial.print(inValDiv, BYTE);
      Serial.print(inVal-(inValDiv*8), BYTE);
      inVal = inputVals[4];
      inValDiv = inVal/8;
      Serial.print(inValDiv, BYTE);
      Serial.print(inVal-(inValDiv*8), BYTE);

      // Outputs 0-4
      int outVal = outputVals[0];
      int outValDiv = outVal/8;
      Serial.print(outValDiv, BYTE);
      Serial.print((outVal-(outValDiv*8)) | ((outputType[0]&0x07)<<4), BYTE);
      outVal = outputVals[1];
      outValDiv = outVal/8;
      Serial.print(outValDiv, BYTE);
      Serial.print((outVal-(outValDiv*8)) | ((outputType[1]&0x07)<<4), BYTE);
      outVal = outputVals[2];
      outValDiv = outVal/8;
      Serial.print(outValDiv, BYTE);
      Serial.print((outVal-(outValDiv*8)) | ((outputType[2]&0x07)<<4), BYTE);
      outVal = outputVals[3];
      outValDiv = outVal/8;
      Serial.print(outValDiv, BYTE);
      Serial.print((outVal-(outValDiv*8)) | ((outputType[3]&0x07)<<4), BYTE);
      outVal = outputVals[4];
      outValDiv = outVal/8;
      Serial.print(outValDiv, BYTE);
      Serial.print((outVal-(outValDiv*8)) | ((outputType[4]&0x07)<<4), BYTE);
            
      // tempVals 0-8
      int tmpVal = tempVals[0];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      tmpVal = tempVals[1];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      tmpVal = tempVals[2];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      tmpVal = tempVals[3];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      tmpVal = tempVals[4];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      tmpVal = tempVals[5];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      tmpVal = tempVals[6];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      tmpVal = tempVals[7];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      tmpVal = tempVals[8];
      Serial.print((tmpVal>>8)&0x00FF, BYTE);
      Serial.print((tmpVal&0x00FF), BYTE);
      
      Serial.print((currentPage&0x00FF), BYTE);
      Serial.print((currentLineOnPage&0x00FF), BYTE);
      int lSince = linesSinceLastRead;
      if(lSince < 0 || lSince > 255){
        lSince = 255;
      }
      Serial.print((lSince&0x00FF), BYTE);
      linesSinceLastRead = 0;

      if(isGoing){
        Serial.print(0x01, BYTE);
      }
      else{
        Serial.print(0x00, BYTE);
      }

      Serial.print(PROTO_CHAR_END);
      break;
    }
  case PROTO_CMD_PAGE_GET:
    {
      //Serial.print("Page get. PAGE=");
      //Serial.print(protocolData[0], HEX);
      // Serial.print(", Section=");
      // Serial.println(protocolData[1], HEX);
      Serial.print(PROTO_CHAR_START);
      Serial.print(26, BYTE);
      Serial.print(PROTO_CMD_PAGE_SET);
      Serial.print(protocolData[0], BYTE); // Page
      Serial.print(protocolData[1], BYTE); // Section
      if(protocolData[0] >= 0 && protocolData[1] >= 0 && protocolData[0] < TOTAL_PAGES && protocolData[1] < 4){
        int p = protocolData[0];
        int s = protocolData[1];
        //int offset = EEPROM_PROG_OFFSET + 2*p*WORDS_PER_PAGE;
        int o = EEPROM_PROG_OFFSET + 2*p*WORDS_PER_PAGE + 2*s*WORDS_PER_SECTION;
        for(i=0; i<12; i++){
          eepromVal = ((EEPROM.read(o + i*2)<<8) & 0xFF00) | (EEPROM.read(o + i*2+1) & 0x00FF);
          UartPrintInstruction(eepromVal);
        }
      }
      else{
        //Serial.println("ERROR >> BAD PAGE!");
        for(i=0; i<3; i++){
          UartPrintInstruction(INS_HEX_DELAY); // if(A,B,C){
          UartPrintInstruction(0xD001); // A = InVAR (Port 2)
          UartPrintInstruction(0xE001); // B = OP/COMP/OUTTYPE (==/+/DIG)
          UartPrintInstruction(0xD001); // C = CONST (100)
        }
      }
      Serial.print(PROTO_CHAR_END);
      break;
    }
  case PROTO_CMD_NOTES_GET:
  {
    Serial.print(PROTO_CHAR_START);
      Serial.print(26, BYTE);
      Serial.print(PROTO_CMD_NOTES_SET);
      Serial.print(protocolData[0], BYTE); // Page
      Serial.print(protocolData[1], BYTE); // Section
      if(protocolData[0] >= 0 && protocolData[1] >= 0 && protocolData[0] < EEPROM_NOTES_PAGES && protocolData[1] < SECTIONS_PER_PAGE){
        int p = protocolData[0];
        int s = protocolData[1];
        int o = EEPROM_NOTES_OFFSET + 2*p*WORDS_PER_PAGE + 2*s*WORDS_PER_SECTION;
        for(i=0; i<24; i++){
          UartPrintChar((char)EEPROM.read(o+i));
        }
      }
      else{
        Serial.println("ERROR >> BAD NOTES PAGE/SECTION!");
        for(i=0; i<24; i++){
          UartPrintChar(' ');
        }
      }
      Serial.print(PROTO_CHAR_END);
    break;
  }
  case PROTO_CMD_PAGE_SET:
    {
      if(protocolData[0] >= 0 && protocolData[1] >= 0 && protocolData[0] < TOTAL_PAGES && protocolData[1] < 4){
        int p = protocolData[0];
        int s = protocolData[1];
        int o = EEPROM_PROG_OFFSET + 2*p*WORDS_PER_PAGE + 2*s*WORDS_PER_SECTION;
        for(i=0; i<12; i++){
          EEPROMwrite(o + i*2, protocolData[2+i*2]);
          EEPROMwrite(o + i*2+1, protocolData[2+i*2+1]);
        }
      }
      else{
         Serial.println("ERROR >> BAD PAGE SET!");
      }
      break;
    }
    case PROTO_CMD_NOTES_SET:
    {
      if(protocolData[0] >= 0 && protocolData[1] >= 0 && protocolData[0] < EEPROM_NOTES_PAGES && protocolData[1] < SECTIONS_PER_PAGE){
        int p = protocolData[0];
        int s = protocolData[1];
        int o = EEPROM_NOTES_OFFSET + 2*p*WORDS_PER_PAGE + 2*s*WORDS_PER_SECTION;
        for(i=0; i<24; i++){
          EEPROMwrite(o + i, protocolData[2+i]);
        }
      }
      else{
         Serial.println("ERROR >> BAD NOTES PAGE SET!");
      }
      break;
    }
  case PROTO_CMD_WORD_SET:
    {
      if(protocolData[0] >= 0 && protocolData[1] >= 0 && protocolData[0] < TOTAL_PAGES && protocolData[1] < 4 && protocolData[2] >= 0 && protocolData[2] < WORDS_PER_PAGE){
        int p = protocolData[0];
        int s = protocolData[1];
        int o = EEPROM_PROG_OFFSET + 2*p*WORDS_PER_PAGE + 2*s*WORDS_PER_SECTION + 2*protocolData[2];
        EEPROMwrite(o, protocolData[3]);
        EEPROMwrite(o+1, protocolData[4]);
        // send response for confirmation...
        Serial.print(PROTO_CHAR_START);
        Serial.print(5, BYTE);
        Serial.print(PROTO_CMD_WORD_SET_CONFIRM);
        Serial.print(protocolData[0], BYTE); // Page
        Serial.print(protocolData[1], BYTE); // Section
        Serial.print(protocolData[2], BYTE); // WordInSection
        Serial.print(protocolData[3], BYTE); // B0
        Serial.print(protocolData[4], BYTE); // B1
        Serial.print(PROTO_CHAR_END);
      }
      else{
        Serial.println("ERROR >> BAD WORD SET!");
      }
      break;
    }
  case PROTO_CMD_RESET:
    {
      // RESET!
      softwareReset();
      break;
    }
  case PROTO_CMD_GOING_SET: 
    {
      if(protocolData[0] == 0x01){
        isGoing = true;
      }
      else{
        isGoing = false;
      }
      break;
    }
  default: 
    {
      Serial.print("ERROR >> Unknown command >> ");
      Serial.println(protocolCmd);
    }
  }
}

void UartPrintInstruction(int ins){
  int dIns = ins>>8;
  Serial.print((ins>>8) & 0x00FF, BYTE);
  Serial.print(ins & 0x00FF, BYTE);
}

void UartPrintChar(char c){
  Serial.print(c, BYTE);
}

void softwareReset(){
  // we don't want to fully reset the device since that will kill the serial port...
  // just clear out all variables and reset pins.
  Serial.println("DEVICE RESTARTING");
  delay(100);
  deviceHasBeenReset = true;
}



